Scriptname ELEMMeteorActorScript extends Actor  
{Makes a summoned Meteor do fun things}
import game
import utility

;===============================================
;	PROPERTIES & VARIABLES
;===============================================
; visual effect shader that appears when main meteor falls
EffectShader Property MeteorTrailShader Auto

ImageSpaceModifier Property ImpactImod auto

spell property SmallMeteorSpell auto
spell property SmallMeteorAltSpell auto
spell property MeteorImpactSpell auto
spell property MeteorImpactVaporizeSpell auto
spell property MeteorTrailSpell auto

ImpactDataSet property FXDragonTakeoffImpactSet auto
ImpactDataSEt property WPNzCrGiantClubImpactSet auto

Static property ImpactSmoke auto
;Actorbase property SummonExtra auto
float property DelayBetweenSmall auto
projectile property MeteorTrailProjectile auto
hazard property MeteorHazard auto
hazard property BlastHazard auto
static property MeteorRock auto
int property numSmallMeteors auto
int property AreaOfEffect auto
;Whether to skip the big one
bool property BigMeteor auto
sound property RumbleSound auto
sound property MeteorSound auto
sound property BlastSound auto
sound property ImpactSound auto
bool MeteorLoaded = FALSE
bool BigBoom = FALSE
bool LeavingTrail = FALSE
bool BlastingAway = FALSE
int rumbleInstanceID
objectreference LeftoverRock
objectreference bigrock


;===============================================
;	EVENTS
;===============================================
EVENT onLoad()
	MeteorLoaded = TRUE
	RegisterForTrackedStatsEvent()
	debug.trace("Meteor loaded!")
	;Game.GetPlayer().DamageActorValue("health", GetPlayer().GetActorValue("health") / 2)
	;Game.GetPlayer().DamageActorValue("stamina", GetPlayer().GetActorValue("stamina") )
	self.knockAreaEffect(0.1,AreaOfEffect)
	SELF.setAlpha(0, TRUE)
	;SELF.setScale(6)
	SELF.enableAI(0)
	float xpos = SELF.GetPositionX()
	float ypos = SELF.GetPositionY()
	float zpos = SELF.GetPositionZ()
	debug.trace("Meteor target position: " + xpos + "X " + ypos + "Y " + zpos + "Z")
	SELF.addSpell(SmallMeteorSpell,false)
	SELF.addSpell(SmallMeteorAltSpell,false)
	SELF.addSpell(MeteorTrailSpell,false)
	SELF.addSpell(MeteorImpactSpell,false)

	rumbleInstanceID = RumbleSound.Play(Game.GetPlayer())

	SELF.TranslateTo(xpos,ypos,zpos + 8000,90,0,0,60000)
	
	utility.wait(1)
	int MeteorCount = 0 
	float randx = 0
	float randy = 0
	int randz = 7000
	int a = 0
	float r = 1000
	float randxa
	float randya
	float randza
	int areaVar = AreaOfEffect
	MeteorCount = 0
	BlastingAway = TRUE
	Debug.Trace("Raising player's defense to an insane amount")
	GetPlayer().ModActorValue("FireResist",50000)
	GetPlayer().ModActorValue("DamageResist",50000)
	GetPlayer().ModActorValue("MagicResist",50000)
	while ((MeteorCount < numSmallMeteors) && (BlastingAway) && (GetPlayer().GetActorValue("magicka") > 10 ))
		Game.GetPlayer().DamageActorValue("magicka", 10)
		randx = (randomInt(0,(AreaOfEffect - areaVar))) - ((AreaOfEffect - areaVar) / 2)
		randy = (randomInt(0,(AreaOfEffect - areaVar))) - ((AreaOfEffect - areaVar) / 2)
		if (areaVar > 0)
			areaVar = areaVar - 100 * MeteorCount
		endIf
		a = 45 * (MeteorCount % 8)
		randx = (math.cos(a) * randx) - (math.sin(a) * randy)
		randy = (math.sin(a) * randx) + (math.cos(a) * randy)
		;randz = utility.randomInt(6000,8000)
		;utility.wait(0.01)
		SELF.TranslateTo(xpos + randx,ypos + randy,zpos + randz,90,0,a,60000)
		debug.trace("Placing small meteor at " + xpos + randx + "X " + ypos + randy + "Y " + zpos + randz + "Z angle:" + a)
		if (MeteorCount % 2 == 0)
			SmallMeteorSpell.RemoteCast(SELF,GetPlayer())
		else
			SmallMeteorAltSpell.RemoteCast(SELF,GetPlayer())
		endIf
		utility.wait(DelayBetweenSmall)
		MeteorCount += 1
	endWhile
	float i = 1
	while (i > 0)
		Sound.SetInstanceVolume(rumbleInstanceID,i)
		debug.trace("Ramping down the rumble to: " + i)
		utility.wait(0.05)
		i -= 0.1
	endWhile
	Sound.StopInstance(rumbleInstanceID)
	debug.trace("BigMeteor: "+BigMeteor)
	if (BigMeteor == TRUE) ;We're not skipping the big one
	debug.trace("Doing the big one!")
	SELF.TranslateTo(xpos,ypos,zpos + 8000,90,0,0,60000)
	;SELF.PlaceAtMe(MeteorTrailSpell)
	;SELF.enableAI(1)
	;SELF.ApplyHavokImpulse(0,0,-1,10000)
	;MeteorTrailSpell.RemoteCast(SELF,Game.GetPlayer())
	bigrock = SELF.PlaceAtMe(MeteorHazard)
	bigrock.setscale(0.01)
	debug.trace("Spawning giant rock")
	SELF.TranslateTo(xpos,ypos,zpos + 8500,90,0,0,60000)
	bigrock.setMotionType(bigrock.Motion_Keyframed)
	;bigrock.disable(0)
	if (numSmallMeteors > 0) 
		utility.wait(1.8)
	endIf
	debug.trace("Dropping self")
	SELF.TranslateTo(xpos,ypos,zpos,90,0,0,8000)	
	utility.wait(0.05)
	;bigrock.enable(0)
	bigrock.setscale(6)
	MeteorTrailShader.Play(bigrock)
	utility.wait(0.05)
	debug.trace("Dropping giant rock")
	bigrock.TranslateTo(xpos,ypos,zpos - 1000,0,0,utility.randomint(0,359),8500)
	BigBoom = TRUE
	LeavingTrail = TRUE
	objectreference trail
	objectreference trailsmoke
	float trailxpos
	float trailypos
	float trailzpos
	while ((SELF.GetPositionZ() != zpos) && (LeavingTrail == TRUE))
		trail = SELF.PlaceAtMe(MeteorTrailProjectile)
		debug.trace("Spawning trail")
		trail.setscale(7)
		utility.wait(0.01)
		MeteorTrailSpell.RemoteCast(SELF,Game.GetPlayer())
		debug.trace("Spawning fireball")
	endWhile

	else ;We are skipping the big one!
		debug.trace("SKIPPING the big one!")
		self.disable()
		self.kill()
	endIf
endEVENT
;===============================================
;===============================================
Event OnTranslationComplete()
	If (BigBoom == TRUE)
		debug.trace("IMPACT!")
		objectreference hugeBlast
		ImpactSound.Play(Game.GetPlayer())
		ImpactImod.Apply(1)
		MeteorImpactVaporizeSpell.RemoteCast(SELF,Game.GetPlayer())
		MeteorImpactSpell.RemoteCast(SELF,Game.GetPlayer())
		int blastInstanceID = BlastSound.Play(Game.GetPlayer())
		self.knockAreaEffect(1,3072)
		PlayImpactEffect(FXDragonTakeoffImpactSet, "BODY", 0, 0, -1, 2048)
		LeavingTrail = FALSE
		int i = 0
		;SELF.TranslateTo(SELF.GetPositionX(),SELF.GetPositionY(),SELF.GetPositionZ(),utility.RandomInt(0,359),0,0,50000)
		SELF.MoveTo(SELF,0,0,-50)
		SELF.SetAngle(0,0,utility.randomint(0,359))
		LeftoverRock = SELF.PlaceAtMe(MeteorRock)
		LeftoverRock.setScale(0.9)
		;MeteorTrailShader.Play(LeftoverRock,5)
		objectreference debrisrock
		objectreference trailsmoke
		SELF.MoveTo(SELF,0,0,50)
		bigrock.delete()
		PlayImpactEffect(WPNzCrGiantClubImpactSet, "BODY", 0, 0, -1, 512)
		while (i < 12 )
			debrisrock = SELF.PlaceAtMe(MeteorHazard)
			debrisrock.setScale(4 - (i/4))
			MeteorTrailShader.Play(debrisrock)
			debrisrock.applyHavokImpulse(0,0,-1,4000 + randomInt(-3000,3000))
			i += 1
		endWhile
		int j = 0
		objectreference burninating
		burninating = self.placeAtMe(BlastHazard)
		burninating.setScale(4)
;		SELF.MoveTo(SELF,0,0,-20)
		SELF.SetAngle(0,0,0)
		While (j < 360)
			SELF.SetAngle(0,0,j)
			trailsmoke = SELF.PlaceAtMe(ImpactSmoke)
			Wait(0.05)
			trailsmoke.setScale(0.1)
			j += 36
		EndWhile
;		SELF.MoveTo(SELF,0,0,20)
		Disable(SELF)
		SELF.Kill()
	EndIf
EndEvent
;===============================================
;===============================================
EVENT onUnload()
	BlastingAway = FALSE
	int i = 0
	objectreference trailsmoke
	while (i < 10)
		;Self.SetAngle(0,0,randomint(0,359))
		trailsmoke = SELF.PlaceAtMe(ImpactSmoke)
		trailsmoke.setScale(randomfloat(0.5,1))
		i += 1
		utility.wait(0.1)
	endWhile
;	utility.wait(3)
	objectreference debrisrock
	i = 0
	while ((i < 2 ) && (BigMeteor == TRUE))
		Self.SetAngle(randomint(0,359),randomint(0,359),randomint(0,359))
		debrisrock = SELF.PlaceAtMe(MeteorHazard)
		Self.MoveTo(Self,0,0,10)
		debrisrock.setScale(randomFloat(2,3))
		debrisrock.applyHavokImpulse(0,0,1,0.1)
		i += 1
	endWhile
	if (BigMeteor== TRUE)
		LeftoverRock.Disable(0)
	EndIf
	Debug.Trace("Setting player's defence back to normal")
	GetPlayer().ModActorValue("FireResist",-50000)
	GetPlayer().ModActorValue("DamageResist",-50000)
	GetPlayer().ModActorValue("MagicResist",-50000)
	if (BigMeteor== TRUE)
		LeftoverRock.Delete()
	EndIf
ENDEVENT
EVENT onDying(actor myKiller)
	BlastingAway = FALSE
ENDEVENT

EVENT onDeath(actor myKiller)
	BlastingAway = FALSE
ENDEVENT

Event OnTrackedStatsEvent(string asStatFilter, int aiStatValue)
	Debug.Trace("Event: " + asStatFilter + " is " + aiStatValue)
endEvent

